
#include <stdio.h>
#include <stdlib.h>

  struct el { char duom;
              struct el *kitas;
              struct el *pries;
            };

int Sukurti_sar ( struct el ** , struct el**);
void Spausdinti_sar ( struct el * );
void Naikinti_sar ( struct el ** , struct el** );
void Pertvarkyti (struct el **, struct el **, int, int, int );

int main()
{
   struct el *pradzia, *pabaiga, *elem;
   int x, pos, reiksme;

   x = Sukurti_sar ( &pradzia, &pabaiga);
//   if (pradzia != pabaiga)
 //  {
     Spausdinti_sar (pradzia);
     printf ("Iveskite reiksme, kuria norite nukopijuoti:\n");
     scanf ("%d", &reiksme);
     printf ("Iveskite po kurio elemento norite iterpti norodytaji:\n");
     scanf ("%d", &pos);
     Pertvarkyti (&pradzia, &pabaiga, x, reiksme, pos);
     Spausdinti_sar ( pradzia );
     Naikinti_sar (&pradzia, &pabaiga);
  // }

   scanf("%d", &x); // nereikalinga
   return 0; /* tik Windows */
}


/* Iterpti elementa i saraso pradzia. */

int Sukurti_sar ( struct el **pr, struct el **pab)
  {
  struct el *g, *temp;
  int reiksme, tmp, kiek = 0;

  puts ("Iveskite saraso elementus. Noredami baigti, iveskite 0:" );
  *pr = NULL;
  *pab = NULL;
  scanf("%char", &reiksme);
  tmp = reiksme;
  while( reiksme != 0 )
   {
     if ( *pr == NULL)
       {
         g = (struct el *) malloc(sizeof(struct el));
         g->duom = reiksme;
         g->kitas = NULL;
         g->pries = NULL;
         *pab = g;
         *pr = g;
         temp = g;
         kiek++;
       }
     else
       {
       g = (struct el *) malloc(sizeof(struct el));
       g->duom = reiksme;
       g->kitas = NULL;
       g->pries = tmp;
       temp = g;
       (*pab)->kitas = g;
       *pab = g;
       kiek++;
       }
    scanf( "%d", &reiksme );
  }
  if (tmp == 0)
    puts("Sarasas tuscias");
  else puts("Sarasas sekmingai sukurtas");
  return kiek;
}



/* Spausdinti nuo pradzios */
void Spausdinti_sar (struct el *elem)
{
  int i=1;
  puts("*****************************************");
  puts("Spausdiname sarasa:");
  while ( elem != NULL )
    {
    printf( "%d elementas yra %d\n", i, elem->duom );
    elem = elem->kitas;
    i++;
    }
}
 void Pertvarkyti (struct el **pr, struct el **pab, int kiek, int reiksme, int pos)
{
  struct el *s, *g;
  int i = 1;
  short int arRasta = 0;            // 1 - jei reiksme rasta, 0 - kitu atveju

  if (pr != NULL) {
        s = *pr;

        if (s->duom == reiksme)
                arRasta = 1;
        while ((i<kiek)&&(arRasta == 0)){
                s = s->kitas;
                if (s->duom == reiksme)
                        arRasta = 1;
                i++;
        }

        if (arRasta == 0)
                printf ("Nurodytas elementas nerastas.\n");
        else {
                i = 1;
                s = *pr;
                if ((pos > kiek)||(pos < 1))
                        printf ("Klaidingai nurodyta pozicija.\n");
                else
                        if (pos == kiek){
                                g = (struct el *) malloc(sizeof(struct el));
                                g->duom = reiksme;
                                g->kitas = NULL;
                                g->pries = *pab;
                                (*pab)->kitas = g;
                                *pab = g;
                        } else {
                                while (i != pos) {
                                        s = s->kitas;
                                        i++;
                                }
                                g = (struct el *) malloc(sizeof(struct el));
                                g->duom = reiksme;
                                g->kitas = s->kitas;
                                g->pries = s;
                                s->kitas->pries = g;
                                s->kitas = g;
                        }
        }
  }
};



/*Naikinti sarasa */
void Naikinti_sar ( struct el * *pr, struct el * *pab )
{
  struct el *einam;

  puts("*****************************************");
  puts("Naikiname sarasa nuo pabaigos:");
  while (*pr != NULL)
    {
    einam = *pr;
    if ( *pab != *pr )
      {
      while ( einam->kitas != *pab )
        einam = einam->kitas;
        *pab = einam;
        printf(" %d ", einam->kitas->duom );
        free ( einam->kitas );
      }
    else
      {
      printf( " %d. \n ", einam->duom );
      free ( einam );
      *pr = NULL;
      *pab = NULL;
      }
    } /* while */
}; /* Naikinti_sar */
